#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <SDL2/SDL.h>

// This function was copied from the SDL2-2.0.1 source (with some modifications).
// So you can try my proposed modification without recompiling SDL.
// From src/audio/SDL_audiotypecvt.c, but that file is generated by sdlgenaudiocvt.pl, so the latter be fixed instead.
static void SDLCALL
SDL_Upsample_S16LSB_1c(SDL_AudioCVT * cvt/*, SDL_AudioFormat format*/)
{
#if DEBUG_CONVERT
    fprintf(stderr, "Upsample arbitrary (x%f) AUDIO_S16LSB, 1 channels.\n", cvt->rate_incr);
#endif

    const int srcsize = cvt->len_cvt - 32;
#if 1 // 0 or 1
	// 1: WRONG
    const int dstsize = (int) (((double)cvt->len_cvt) * cvt->rate_incr);
#else
	// 0: RIGHT
    const int dstsize = (int) (((double)(cvt->len_cvt/2)) * cvt->rate_incr) *2;
#endif
    register int eps = 0;
    Sint16 *dst = ((Sint16 *) (cvt->buf + dstsize)) - 1;
    const Sint16 *src = ((Sint16 *) (cvt->buf + cvt->len_cvt)) - 1;
    const Sint16 *target = ((const Sint16 *) cvt->buf);
    Sint16 sample0 = ((Sint16) SDL_SwapLE16(src[0]));
    Sint16 last_sample0 = sample0;
    while (dst >= target) {
        dst[0] = ((Sint16) SDL_SwapLE16(sample0));
        dst--;
        eps += srcsize;
        if ((eps << 1) >= dstsize) {
            src--;
            sample0 = (Sint16) ((((Sint32) ((Sint16) SDL_SwapLE16(src[0]))) + ((Sint32) last_sample0)) >> 1);
            last_sample0 = sample0;
            eps -= dstsize;
        }
    }
    cvt->len_cvt = dstsize;
    /*
    if (cvt->filters[++cvt->filter_index]) {
        cvt->filters[cvt->filter_index] (cvt, format);
    }
    */
}

int main(int argc, char *argv[]) {
	int i;
	SDL_AudioCVT cvt;
	Uint8 *data;
	Uint32 dlen;
	
	const int old_sample_rate = 20;
	const int new_sample_rate = 21;
	const int old_channels = 1;
	const int new_channels = 1;
	const int old_sample_count = 2*0x30;
	const int old_format = AUDIO_S16;
	const int old_bytes_per_sample = SDL_AUDIO_BITSIZE(old_format) / 8;
	const int new_format = AUDIO_S16;
	const int old_byte_length = old_channels * old_sample_count * old_bytes_per_sample;

	data = malloc(old_byte_length);
	dlen = old_byte_length;
	// Build a "sound" whose samples are all the same.
	for (i=0; i<old_sample_count * old_channels; i++) {
		((Sint16*)data)[i] = 0x100;
	}

 	if (SDL_BuildAudioCVT (&cvt,
		old_format, old_channels, old_sample_rate,
		new_format, new_channels, new_sample_rate
	) != 1) {
		printf ("[FAILED] SDL_BuildAudioCVT: %s\n", SDL_GetError());
		exit (1);
	}

	// "+1" is to work around an (other) SDL bug. ( https://bugzilla.libsdl.org/show_bug.cgi?id=2274 ) 
	cvt.buf = (Uint8 *)malloc (dlen*(cvt.len_mult+1));
	memcpy (cvt.buf, data, dlen);
	cvt.len = dlen;

	// Do the conversion.
#if 1 // 0 or 1
	// 1: use SDL
	if (SDL_ConvertAudio (&cvt) != 0) {
		printf ("[FAILED] SDL_ConvertAudio: %s\n", SDL_GetError());
		exit (1);
	}
#else
	// 0: use the function copied from SDL
	cvt.len_cvt = cvt.len;
	SDL_Upsample_S16LSB_1c(&cvt);
#endif
	
	// All samples of the result should be 0x0100.
	// And its length (in bytes) should be even.
	
	// Dump the result to stdout.
	printf("After conversion:");
	for (i=0; i<cvt.len_cvt; i++) {
		printf(" %02X", cvt.buf[i]);
	}
	printf("\n");
	printf("cvt.len_cvt = %d", cvt.len_cvt);

	// Dump the result into a file.
	int iFd = open ("result.raw", O_WRONLY|O_TRUNC|O_CREAT|O_BINARY, 0600);
	write(iFd, cvt.buf, cvt.len_cvt);
	close(iFd);

	return 0;
}
